#!/bin/bash

source /Node/bin/env.sh

if test "$backupdir" == "" ; then
	backupdir=/backup
fi


if test "$DBS" == "" ; then
  echo "Please define variable DBS in /Node/bin/env.sh containing the databases to dump."
  exit 1
fi

if ! test -e $backupdir ; then
	mkdir $backupdir
fi

if ! test -w $backupdir ; then
	echo "$backupdir is not writable :("
	exit 1
fi


for db in $DBS; do
	/Node/mysql/bin/mysqldump --skip-set-charset --default-character-set=latin1 -d $db |
        	sed "s/ DEFAULT CHARSET=latin1//" |
	        sed "s/ ENGINE=MyISAM/ ENGINE=InnoDB/"> $backupdir/$db.struct.sql
	/Node/mysql/bin/mysqldump --skip-set-charset --default-character-set=latin1 --no-autocommit -Ket $db | gzip > $backupdir/$db.data.sql.gz
done

read -p "Press enter to stop node package and create database backup."

/Node/bin/nodectl stop

sleep 5

echo "Creating database backup."

tar czf $backupdir/mysql_var_date.tar.gz -C /Node/var mysql

echo "Created $backupdir/mysql_var_date.tar.gz"

