<?








class NodeCache extends NodeObject {

 var $parserkey;
 var $cacheId;
 var $d_cached;
 var $d_output;
 var $d_reload;
 var $d_inputCount = 0;
 var $d_cacheHits = 0;

 function NodeCache($id = 0, $parserkey = "") {
 parent::BaseObject();
 $this->parserkey = $parserkey;
 $this->cacheId = $id;
 $this->d_cached = false;
 $this->d_output = array();
 $this->setID($id);
 }

 function getTType() {
 global $T_NODECACHE;
 return $T_NODECACHE;
 }

 function _setID($id) {
 $sql = "SELECT id, parser, reload, output FROM nodecache WHERE id = ".(int) $id;
 $rs = query($sql);
 if ($rs["num"] == 0) {
 $this->cacheID = 0;
 $this->d_cached = false;
 $this->d_output = array();
 $this->d_reload = 0;
 } else {
 $this->cacheID = (int) $id;
 $this->d_cached = !$rs["arr"][0]["reload"];
 $this->d_output = $this->_unserializeOutput($rs["arr"][0]["output"]);
 $this->parserkey = $rs["arr"][0]["parser"];
 $this->d_reload = $rs["arr"][0]["reload"];
 }
 }

 function onEventNotify( $TType, $id, $changeType, $linkType, $eventObject, $depth, $simulate ) {
 
 switch ($linkType) {
 case LINKT_PARSERCACHE:
 $this->refreshEntry($this->cacheID);
 break;
 }
 }

 function getID() {
 return $this->cacheID;
 }

 



 function clearObjectLinks($obj) {
 $sql = "DELETE FROM nodecache_object WHERE o_id = ".sqlf_tl_num($obj->getID())." AND o_type = ".sqlf_tl_num($obj->getTType());
 query($sql);
 }

 



 function cleanup() {
 $sql = "SELECT id FROM nodecache LEFT JOIN nodecache_object ON nodecache.id = nodecache_object.nodecache_id 
		        WHERE nodecache_object.o_id IS NULL";
 $rs = query($sql);
 while (list($key, $val) = each($rs["arr"])) {
 $id = $val["id"];
 $sql = "DELETE FROM nodecache WHERE id = ".sqlf_tl_num($id);
 query($sql);
 $sql = "DELETE FROM nodecache_event WHERE nodecache_id = ".sqlf_tl_num($id);
 query($sql);
 
 }
 }

 






 function refreshEntries($obj, $changeLinkEvent) {
 global $T_NODECACHE;
 $sql = "SELECT DISTINCT id FROM nodecache, nodecache_object WHERE nodecache.id = nodecache_object.nodecache_id
		        AND nodecache_object.o_id = ".sqlf_tl_num($obj->getID())." AND nodecache_object.o_type = ".sqlf_tl_num($obj->getTType())." AND reload = 0";
 $rs = query($sql);
 while (list($key, $val) = each($rs["arr"])) {
 $sql = "UPDATE nodecache SET reload = 1 WHERE id = ".sqlf_tl_num($val["id"]);
 query($sql);
 addEventDependency($T_NODECACHE, $val["id"], EVENT_ALL, $obj->getTType(), $obj->getID(), $changeLinkEvent);
 }
 }

 






 function refreshObjects($parser, $type, $keyname, $interval = 0) {
 global $T_NODECACHE, $TIME;
 $sqlwhere = "nodecache.parser = \"".sqlslashes($parser)."\" AND nodecache.type = \"".sqlslashes($type)."\" 
		             AND nodecache.keyname = \"".sqlslashes($keyname)."\" AND nodecache.reload = 0";
 if ($interval > 0) {
 $sqlwhere .= " AND nodecache.lastupdate < ".sqlf_tl_num($TIME - $interval);
 }
 $sql = "SELECT no.o_id, no.o_type, nodecache.id, no.linktype FROM nodecache, nodecache_object AS no WHERE nodecache.id = no.nodecache_id AND $sqlwhere 
		        GROUP BY no.o_id, no.o_type, nodecache.id";
 $rs = query($sql);
 while (list($key,$val) = each($rs["arr"])) {
 addEventDependency($T_NODECACHE, $val["id"], EVENT_ALL, $val["o_type"], $val["o_id"], $val["linktype"]);
 }
 
 $sql = "UPDATE nodecache SET reload = 1 WHERE $sqlwhere";
 query($sql);
 }

 





 function refreshCache($parser = false) {
 global $T_NODECACHE;
 $sqlwhere = "nodecache.reload = 0";
 if ($parser !== false) $sqlwhere .= " AND nodecache.parser = \"".sqlslashes($parser)."\"";
 $sql = "SELECT no.o_id, no.o_type, nodecache.id, no.linktype FROM nodecache, nodecache_object AS no WHERE nodecache.id = no.nodecache_id AND $sqlwhere 
		        GROUP BY no.o_id, no.o_type, nodecache.id";
 $rs = query($sql);
 while (list($key,$val) = each($rs["arr"])) {
 addEventDependency($T_NODECACHE, $val["id"], EVENT_ALL, $val["o_type"], $val["o_id"], $val["linktype"]);
 }
 
 $sql = "UPDATE nodecache SET reload = 1 WHERE $sqlwhere";
 query($sql);
 }

 function refreshEntry($id) {
 global $T_NODECACHE;
 $sql = "SELECT no.o_id, no.o_type, nodecache.id, no.linktype FROM nodecache, nodecache_object AS no WHERE nodecache.id = no.nodecache_id AND id = ".sqlf_tl_num($id)." 
		        GROUP BY no.o_id, no.o_type, nodecache.id";
 $rs = query($sql);
 while (list($key,$val) = each($rs["arr"])) {
 addEventDependency($T_NODECACHE, $val["id"], EVENT_ALL, $val["o_type"], $val["o_id"], $val["linktype"]);
 }
 
 $sql = "UPDATE nodecache SET reload = 1 WHERE id = ".sqlf_tl_num($id);
 query($sql);

 }

 






 function updateCache($force = false, $LOG_FILE_POINTER = false) {
 global $T_NODECACHE, $TIME, $MAX_RUN_CACHE_CLEAR, $DEBUG;
 $sql = "SELECT id, parser, type, keyname, properties, tagkey, input FROM nodecache";
 if (!$force) $sql .= " WHERE reload = 1";
 
 $rs = query($sql);
 if ($rs["num"] == 0) return false;

 $aParser = array();
 node_class("parserfactory");
 while (list($key, $val) = each($rs["arr"])) {
 if (isset($MAX_RUN_CACHE_CLEAR)) {
 set_time_limit($MAX_RUN_CACHE_CLEAR);
 }

 if ($DEBUG['nodecache']) {
 if ($LOG_FILE_POINTER && function_exists('log_publish') ) {
 log_publish($LOG_FILE_POINTER, "-- Init Parser:\nParser: ".$val['parser']."\nType: ".$val['type']."\n--\n");
 }
 }

 
 if (!isset($aParser[$val["parser"]])) {
 $aParser[$val["parser"]] =& ParserFactory::getInstanceOf($val["parser"]);
 $aParser[$val["parser"]]->setEvaluate(true);
 }
 $parser = $aParser[$val["parser"]]->getObjectParser($val["type"]);
 $parser->setKeyname($val["keyname"]);
 $props = unserialize($val["properties"]);

 NodeCache::clearCacheDependencies($val["id"]);

 if ($DEBUG['nodecache']) {
 if ($LOG_FILE_POINTER && function_exists('log_publish') ) {
 log_publish($LOG_FILE_POINTER, "-- parsing:\n".$val['input']."\n--\n");
 }
 $t1 = microtime();
 }

 
 $outp = $parser->parse($val["input"], $props, $force);
 
 if ($DEBUG['nodecache']) {
 $dt = calctime($t1, microtime(), 6);
 if ($LOG_FILE_POINTER && function_exists('log_publish') ) {
 log_publish($LOG_FILE_POINTER, "\n-- Done in $dt --\n");
 }
 }
 }
 
 removeEventDependencies($T_NODECACHE,0,2);

 return true;
 }

 





 function clearCache() {
 $sql = "DELETE FROM nodecache";
 query($sql);
 $sql = "DELETE FROM nodecache_object";
 query($sql);
 $sql = "DELETE FROM nodecache_event";
 query($sql);
 
 resetEventDependencies($T_NODECACHE,0,2);
 }

 



 function setInput($type, $keyname, $input, $props, $tagKey = "") {
 global $DEBUG;
 if ( $DEBUG["nodecache"] && $DEBUG["echo"] )
 echo "cache: input=".htmlentities_utf8($input)."<br />";

 $this->d_inputCount++;
 $sparser = sqlslashes($this->parserkey);
 $stype = sqlslashes($type);
 $skeyname = sqlslashes($keyname);
 $sinput = sqlslashes($input);
 $sprops = sqlslashes(serialize($props));
 $stagkey = sqlslashes(serialize($tagKey));
 $sql = "SELECT id, output, reload FROM nodecache WHERE parser = \"$sparser\" AND type = \"$stype\" AND keyname = \"$skeyname\"
		        AND input = \"$sinput\" AND properties = \"$sprops\" AND tagkey = \"$stagkey\"";
 $rs = query($sql, 1);
 if ($rs["num"] == 0) {
 $sql = "INSERT INTO nodecache (parser, type, keyname, properties, tagkey, input, output, reload) VALUES 
			        (\"$sparser\",\"$stype\",\"$skeyname\",\"$sprops\",\"$stagkey\",\"$sinput\",\"\",1)";
 $rs = query($sql);
 $this->cacheID = $rs["iid"];
 $this->d_cached = false;
 $this->d_output = array();
 $this->d_reload = 1;
 } else if ($rs["arr"][0]["reload"] == 1) {
 $this->cacheID = $rs["arr"][0]["id"];
 $this->d_cached = false;
 $this->d_output = array();
 $this->d_reload = 1;
 } else {
 $this->d_cacheHits++;
 $this->cacheID = $rs["arr"][0]["id"];
 $this->d_cached = true;
 $this->d_output = $this->_unserializeOutput($rs["arr"][0]["output"]);
 $this->d_reload = $rs["arr"][0]["reload"];
 }
 if ( $DEBUG["nodecache"] && $DEBUG["echo"] )
 echo ($this->d_cached?"cached.":"not cached.")."<br />";
 }

 function isCached() {
 return $this->d_cached;
 }

 function getOutput() {
 return $this->d_output;
 }
 
 






 function setOutput($output) {
 global $TIME, $T_NODECACHE;
 if (!$this->cacheID) return false;
 $sql = "SELECT output FROM nodecache WHERE id = ".sqlf_tl_num($this->cacheID);
 $rs = query($sql);
 
 $sql = "UPDATE nodecache SET lastupdate = ".sqlf_tl_num($TIME).", reload = 0 WHERE id = ".sqlf_tl_num($this->cacheID);
 query($sql);
 
 if (NodeCache::_compareOutput($rs["arr"][0]["output"], $output)) return false;
 
 $soutput = $this->_serializeOutput($output);
 $sql = "UPDATE nodecache SET output = \"".sqlslashes($soutput)."\" WHERE id = ".sqlf_tl_num($this->cacheID);
 query($sql);
 
 triggerEvent($T_NODECACHE, $this->cacheID, EVENT_UPDATE, new EventObject() );
 
 return true;
 }

 function linkToObject($obj, $linkType) {
 global $T_NODECACHE;
 if (!$this->cacheID) return false;
 if (!is_object($obj)) return false;
 $sql = "SELECT nodecache_id FROM nodecache_object WHERE nodecache_id = ".sqlf_tl_num($this->cacheID)." AND o_id = ".sqlf_tl_num($obj->getID())." AND o_type = ".sqlf_tl_num($obj->getTType());
 $rs = query($sql);
 if ($rs["num"] == 0) {
 $sql = "INSERT INTO nodecache_object (nodecache_id, o_id, o_type, linktype) VALUES (".sqlf_tl_num($this->cacheID).", ".sqlf_tl_num($obj->getID()).", ".sqlf_tl_num($obj->getTType()).", ".sqlf_tl_num($linkType).")";
 query($sql);
 }
 if ($this->d_reload) {
 addEventDependency($T_NODECACHE, $this->cacheID, EVENT_ALL, $obj->getTType(), $obj->getID(), $linkType);
 }
 }

 function addDependency($eventType, $eventID, $onEventType, $ignoreEvent = 0) {
 global $T_NODECACHE;
 if (!$this->cacheID) return false;
 $sql = "SELECT nodecache_id FROM nodecache_event WHERE nodecache_id = ".sqlf_tl_num($this->cacheID)." AND o_id = ".sqlf_tl_num($eventID)." AND o_type = ".sqlf_tl_num($eventType)."
		        AND eventtype = ".sqlf_tl_num($onEventType)." AND ignoreevent = ".sqlf_tl_num($ignoreEvent);
 $rs = query($sql);
 if ($rs["num"] == 0) {
 $sql = "INSERT INTO nodecache_event (nodecache_id, o_id, o_type, eventtype, ignoreevent) VALUES 
			        (".sqlf_tl_num($this->cacheID).", ".sqlf_tl_num($eventID).", ".sqlf_tl_num($eventType).", ".sqlf_tl_num($onEventType).", ".sqlf_tl_num($ignoreEvent).")";
 query($sql);
 }
 addEventDependency($eventType, $eventID, $onEventType, $T_NODECACHE, $this->cacheID, LINKT_PARSERCACHE, $ignoreEvent);
 }

 function getDependencies() {
 if (!$this->cacheID) return false;
 $sql = "SELECT o_id, o_type, eventtype, ignoreevent FROM nodecache_event WHERE nodecache_id = ".sqlf_tl_num($this->cacheID);
 $rs = query($sql);
 return $rs["arr"];
 }

 function restoreDependencies($obj, $linkType) {
 if (!$this->cacheID) return false;
 $rs = $this->getDependencies();
 while (list($key, $val) = each($rs)) {
 addEventDependency($val["o_type"],$val["o_id"],$val["eventtype"], $obj->getTType(), $obj->getID(), $linkType, $val["ignoreevent"]);
 }
 }

 function clearCacheDependencies($id = 0) {
 global $T_NODECACHE;
 if (!$id && is_object($this)) $id = $this->cacheID;
 removeEventDependencies($T_NODECACHE, $id, 2, LINKT_PARSERCACHE);
 }

 function clearCacheEntry() {
 if (!$this->cacheID) return false;
 
 BaseObject::addDebugMessage("NodeCache::clearCacheEntry: not yet implemented!");
 }

 
 
 
 
 function _serializeOutput($output) {
 if (!is_array($output)) $output = array($output);
 foreach($output as $key=>$val) {
 $output[$key] = node_serialize($val);
 }
 return serialize($output);
 }

 function _unserializeOutput($output) {
 if (!$output) return array();
 $output = unserialize($output);
 foreach ($output as $key=>$obj) {
 $output[$key] = &node_unserialize($obj);
 }
 return $output;
 }

 function _compareOutput($sOutput, $output) {
 
 $outp1 = NodeCache::_unserializeOutput($sOutput);
 $outp2 = $output;
 
 if ( count($outp1) != count($outp2) ) return false;
 
 reset($outp1);
 reset($outp2);
 while (list($k1, $obj1) = each($outp1)) {
 if (is_a($obj1,"emessage")) continue;
 
 while ($found = (list($k2, $obj2) = each($outp2))) { if (!is_a($obj2,"emessage")) break; } 
 if ( !$found ) return false;
 if ($obj1->toString() != $obj2->toString()) return false;
 }
 return true;
 }

}

?>
